Module com.io7m.jregions.core
Package com.io7m.jregions.core.unparameterized.areas

## Class AreaBD

- java.lang.Object
- - com.io7m.jregions.core.unparameterized.areas.AreaBD

- All Implemented Interfaces:
    `AreaBDType`, `AreaValuesBDType`, `AreaSizeValuesBDType`

      public final class AreaBD
      extends java.lang.Object
      implements AreaBDType

  An area with `BigDecimal` coordinates.

  The coordinates of the area are given in half-closed form. That is, `minimumX()` refers to the minimum inclusive value on the X axis, and `maximumX()` refers to the maximum exclusive value on the X axis. Likewise for the Y axis.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `AreaBD.Builder` | Builds instances of type `AreaBD`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static AreaBD.Builder` | `builder​()` | Creates a builder for `AreaBD`.
    `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `AreaBD` that have equal attribute values.
    `int` | `hashCode​()` | Computes a hash code from attributes: `minimumX`, `maximumX`, `minimumY`, `maximumY`.
    `java.math.BigDecimal` | `height​()` | Deprecated. Use `AreaValuesBDType.sizeY()`
    `java.math.BigDecimal` | `maximumX​()` |
    `java.math.BigDecimal` | `maximumY​()` |
    `java.math.BigDecimal` | `minimumX​()` |
    `java.math.BigDecimal` | `minimumY​()` |
    `static AreaBD` | `of​(java.math.BigDecimal minimumX, java.math.BigDecimal maximumX, java.math.BigDecimal minimumY, java.math.BigDecimal maximumY)` | Construct a new immutable `AreaBD` instance.
    `java.lang.String` | `toString​()` | Prints the immutable value `AreaBD` with attribute values.
    `java.math.BigDecimal` | `width​()` | Deprecated. Use `AreaValuesBDType.sizeX()`

    - ### Methods inherited from interface com.io7m.jregions.core.unparameterized.areas.AreaBDType

      `checkPreconditions`

    - ### Methods inherited from interface com.io7m.jregions.core.unparameterized.areas.AreaValuesBDType

      `sizeX, sizeY`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### minimumX

          public java.math.BigDecimal minimumX​()

      Specified by:
        `minimumX` in interface `AreaBDType`
      Specified by:
        `minimumX` in interface `AreaValuesBDType`
      Returns:
        The value of the `minimumX` attribute

    - #### maximumX

          public java.math.BigDecimal maximumX​()

      Specified by:
        `maximumX` in interface `AreaBDType`
      Specified by:
        `maximumX` in interface `AreaValuesBDType`
      Returns:
        The value of the `maximumX` attribute

    - #### minimumY

          public java.math.BigDecimal minimumY​()

      Specified by:
        `minimumY` in interface `AreaBDType`
      Specified by:
        `minimumY` in interface `AreaValuesBDType`
      Returns:
        The value of the `minimumY` attribute

    - #### maximumY

          public java.math.BigDecimal maximumY​()

      Specified by:
        `maximumY` in interface `AreaBDType`
      Specified by:
        `maximumY` in interface `AreaValuesBDType`
      Returns:
        The value of the `maximumY` attribute

    - #### width

          @Deprecated
          public java.math.BigDecimal width​()

      Deprecated. Use `AreaValuesBDType.sizeX()`
      Specified by:
        `width` in interface `AreaSizeValuesBDType`
      Returns:
        The width of the area

    - #### height

          @Deprecated
          public java.math.BigDecimal height​()

      Deprecated. Use `AreaValuesBDType.sizeY()`
      Specified by:
        `height` in interface `AreaSizeValuesBDType`
      Returns:
        The height of the area

    - #### equals

          public boolean equals​(java.lang.Object another)

      This instance is equal to all instances of `AreaBD` that have equal attribute values.
      Overrides:
        `equals` in class `java.lang.Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode​()

      Computes a hash code from attributes: `minimumX`, `maximumX`, `minimumY`, `maximumY`.
      Overrides:
        `hashCode` in class `java.lang.Object`
      Returns:
        hashCode value

    - #### toString

          public java.lang.String toString​()

      Prints the immutable value `AreaBD` with attribute values.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        A string representation of the value

    - #### of

          public static AreaBD of​(java.math.BigDecimal minimumX,
                                  java.math.BigDecimal maximumX,
                                  java.math.BigDecimal minimumY,
                                  java.math.BigDecimal maximumY)

      Construct a new immutable `AreaBD` instance.
      Parameters:
        `minimumX` - The value for the `minimumX` attribute
        `maximumX` - The value for the `maximumX` attribute
        `minimumY` - The value for the `minimumY` attribute
        `maximumY` - The value for the `maximumY` attribute
      Returns:
        An immutable AreaBD instance

    - #### builder

          public static AreaBD.Builder builder​()

      Creates a builder for `AreaBD`.
      Returns:
        A new AreaBD builder

Copyright © 2017 <code@io7m.com> http://io7m.com